PFont digits;
int[ ] pos = {0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15}; // tile values
int ex=0, wy=0;                          // position of the empty tile, ie 0
int row, col, temp;                      // tile position where mouse was clicked & a temp
color[ ] shade = new color[16];          // colors of each tile
color tempc;                             // temporary for switching colors

void setup( ) {
  size(400,400);
  background(0, 100, 100);
  digits = loadFont("HelveticaNeue-Bold-25.vlw");
  textFont(digits);
  for(int i = 0; i < shade.length; i++) {  
    shade[i] = color(15, 175-5*i, 175-5*i); // give the unique colors, getting darker
  }
}

void draw( ) {
  fill(10,116,180);
  rect(100, 100, 200,200);                  // color background
  for(int i = 0; i < 4; i++){               // loop through tile positions
    for(int j = 0; j < 4; j++) {
      if(pos[convert(i,j)] != 0) {          // if this isn't the empty position
        stroke(150);                        // make tile edge medium gray
        strokeWeight(2);                    // use 2-wide line for tile edge
        fill(shade[convert(i,j)]);          // locate tile color
        rect(102+50*j, 102+50*i, 46, 46);   // draw tile
        fill(0);                            // set number color to black
        text(pos[convert(i,j)], 102+50*j+10, 102+50*i+30); // place number near tile center    
      }
    }
  }
}

int convert(int xpos, int ypos) {          // convert from 2-D tiles to 1-D position vals
  return xpos*4 + ypos; 
}

void mouseReleased( ) {
  row = (mouseY-100)/50;                            // compute the row the mouse is in
  col = (mouseX-100)/50;                            // compute the column the mouse is in
  if(abs(row-ex) + abs(col-wy) == 1) {              // if the position is 1 away from empty
    temp = pos[convert(ex, wy)];                    // use "3 assignment swap" for position
    pos[convert(ex,wy)]=pos[convert(row,col)];
    pos[convert(row, col)]=temp;
    tempc = shade[convert(ex, wy)];                 // use "3 assignment swap" for color
    shade[convert(ex,wy)]=shade[convert(row,col)];
    shade[convert(row, col)]=tempc;
    ex = row;                                        // remember where the 0
    wy = col;                                        //    is now
  }
}

